<template>
    <div class="container">
      <div class="row mt-2">
        <div class="col-sm-3">
          <div class="input-group">
            <input class="form-control form-control-navbar" @keyup.enter="searchit"
            v-model="search" type="search" placeholder="search" aria-label="search">
            <button class="btn btn-primary" @click="searchit">
              <i class="fa fa-search inline"></i>
            </button>
          </div>
        </div>
      </div>

      <div class="row mt-2">
        <div class="col-12">
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">Users Table</h3>

              <div class="card-tools">
                  <button class="btn btn-success" @click="newModal">Add New <i class="fas fa-user-plus fa-fw"></i></button>
              </div>
            </div>
            <!-- /.card-header -->
            <div class="card-body table-responsive p-0">
              <table class="table table-hover">
                <thead>
                <tr>
                    <th>NIM</th>
                    <th>Name</th>
                    <th>Email</th>
                    <th>Type</th>
                    <th>Registered At</th>
                    <th>Modify</th>
                </tr>
              </thead>
                <tbody>

                  <tr v-for="user in users.data" :key="user.id">
                    <td>{{user.id_pengenal}}</td>
                    <td>{{user.name}}</td>
                    <td>{{user.email}}</td>
                    <td>{{user.type}}</td>
                    <td>{{user.created_at}}</td>
                    <td>
                      <a href="#" @click="editModal(user)">
                        <i class="fa fa-edit blue"></i>
                      </a>
                      /
                      <a href="#" @click="deleteUser(user.id)">
                        <i class="fa fa-trash red"></i>
                      </a>
                    </td>
                  </tr>

              </tbody></table>
            </div>
            <!-- /.card-body -->
            <div class="card-footer">
                <pagination :data="users"
                @pagination-change-page="getResults"></pagination>
            </div>
          </div>
          <!-- /.card -->
        </div>
      </div>

      <!-- Modal -->
      <div class="modal fade" id="addNew" tabindex="-1" role="dialog" aria-labelledby="addNewLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" v-show="!editmode" id="addNewLabel">Add New</h5>
              <h5 class="modal-title" v-show="editmode" id="addNewLabel">Update User's Info</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <form @submit.prevent="editmode ? updateUser() : createUser()">
              <div class="modal-body">
                <div class="form-group">
                  <input v-model="form.name" type="text" name="name"
                    placeholder="Name"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('name') }">
                  <has-error :form="form" field="name"></has-error>
                </div>

                <div class="form-group">
                  <input v-model="form.id_pengenal" type="number" name="id_pengenal"
                    placeholder="Id pengenal"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('id_pengenal') }">
                  <has-error :form="form" field="id_pengenal"></has-error>
                </div>

                <div class="form-group">
                  <input v-model="form.universitas" type="text" name="universitas"
                    placeholder="Universitas"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('universitas') }">
                  <has-error :form="form" field="universitas"></has-error>
                </div>

                <div class="form-group">
                  <select v-model="form.status_mahasiswa"  name="status_mahasiswa"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('status_mahasiswa') }">
                    <option value="">Status Mahasiswa</option>
                    <option value="alumni">Alumni</option>
                    <option value="mahasiswa">Mahasiswa</option>
                  </select>
                  <has-error :form="form" field="status_mahasiswa"></has-error>
                </div>


                <div class="form-group">
                  <input v-model="form.email" type="email" name="email"
                    placeholder="Email Address"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('email') }">
                  <has-error :form="form" field="email"></has-error>
                </div>

                <div class="form-group">
                  <select v-model="form.type"  name="type"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('bio') }">
                    <option value="">Select User Role</option>
                    <option value="hlpl">Admin HLPL</option>
                    <option value="tracer">Admin Tracer Study</option>
                    <option value="karir">Admin Karir</option>
                    <option value="mahasiswa-telu">Mahasiswa Tel-U</option>
                    <option value="lulusan-telu">Lulusan Tel-U</option>
                    <option value="mahasiswa-umum">Mahasiswa Umum</option>
                    <option value="lulusan-umum">Lulusan Umum</option>
                    <option value="direkturcdc">Direktur CDC</option>
                    <option value="kaprodi">Kaprodi</option>
                  </select>
                  <has-error :form="form" field="bio"></has-error>
                </div>

                <div class="form-group">
                  <input v-model="form.password" type="password" name="password" placeholder="Password"
                    class="form-control" :class="{ 'is-invalid': form.errors.has('password') }">
                  <has-error :form="form" field="password"></has-error>
                </div>

              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
                <button v-show="editmode" type="submit" class="btn btn-success">Update</button>
                <button v-show="!editmode" type="submit" class="btn btn-primary">Create</button>
              </div>
            </form>
        </div>
      </div>
      </div>


    </div>
</template>



<script>
import Form from 'vform'

    export default {
        data() {
          return {
              search: '',
              editmode: false,
              users : {},
              form: new Form({
                id:'',
                name: '',
                email: '',
                password: '',
                type: '',
                universitas:'',
                status_mahasiswa:'',
                id_pengenal:''
              })
          }
        },
        methods: {
            searchit(){
              let query = this.search;
              axios.get('api/findUser?q='+query)
              .then((data) => {
                this.users = data.data
              })
              .catch(() =>{

              })
            },
            getResults(page = 1) {
              axios.get('api/user?page=' + page)
                .then(response => {
                  this.users = response.data;
                });
            },
            updateUser(){
              //  console.log('Editing data');
              this.form.put('api/user/'+this.form.id)
              .then(() => {
                swal(
                  'Updated!',
                  'Your file has been updated.',
                  'success'
                )
                $('#addNew').modal('hide')
                this.loadUsers();
              })
              .catch(() => {

              });
            },
            editModal(user){
              this.editmode = true;
              this.form.reset();
              $('#addNew').modal('show');
              this.form.fill(user);

            },
            newModal(){
              this.editmode = false;
              this.form.reset();
              $('#addNew').modal('show');
            },
            deleteUser(id){
              swal({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
                }).then((result) => {

                  //send request to server
                  if (result.value){
                    this.form.delete('api/user/'+id).then(()=>{
                      swal(
                        'Deleted!',
                        'Your file has been deleted.',
                        'success'
                      )
                      this.loadUsers();
                    }).catch(()=>{
                      swal("Failed!","There was something wrong.","warning");
                    });
                  }

              })
            },
            loadUsers(){
                axios.get("api/user").then(({data}) => (this.users = data));
            },
            createUser(){
                this.form.post('api/user')
                .then(()=>{
                  $('#addNew').modal('hide')

                  toast({
                    type: 'success',
                    title: 'User created successfully'
                  })
                  this.loadUsers();
                })
            }
        },
        created() {
            this.loadUsers();
        }
    }
</script>
